'Zjiovn datumu a asu
'a dalch informac o souborech pres funkci DOSu INT 21h
'(Zjitno ze Sysmanu)
'-------------------------------------------------------------
'Nastav prenosovou adresu disku (DTA)
'Vstup:  AH   =1Ah
'        DS:DX=Adresa DTA
'Vystup: Neni
'
'DTA muze byt dale vyuzivana funkcemi DOSu 11h,12h,4Eh a 4Fh.
'-------------------------------------------------------------
'ti DTA (vtinou nen nutno)
'Vstup:  AH   =2Fh
'Vystup: ES:BX=Adresa zacatku DTA
'-------------------------------------------------------------
'Najdi prvni soubor:
'Vstup:  AH   =4Eh                                           13
'        DS:DX=Adresa jmena souboru+chr(0)               124862
'        CX   =Atributy souboru, ktere se maji shodovat (RHSVDaxx)
'Vystup: AX   =Je-li nastavena vlajka CF (carry), kod chyby
'        DTA  =Neni-li chyba, je naplnena daty
'-------------------------------------------------------------
'Najdi dal soubor:
'Vstup: AH   =4Fh
'       DS:DX=adresa informace z pedchozho voln 4Eh Najdi soubor
'Vstup:AX   =Je-li nastavena vlajka CF (carry), kd chyby
'       DTA  =Je naplnna daty.
'-------------------------------------------------------------
'Obsah DTA:
'Poz.Del.Obsah
' 0  15h Rezervovano pro dalsi volani 4Fh-Najdi dalsi soubor
'15h  1  Atributy souboru
'16h  2  Cas souboru
'18h  2  Datum souboru
'1Ah  4  Velikost souboru v bytech
'1Eh 0Dh Jmeno souboru+chr(0)
'2Ch     Pozadovana velikost bufferu
'-------------------------------------------------------------
'Atributy souboru:
'       1
'    1362
'12486248
'RHSVDaxx
'
'Napklad CX v 4Eh: 7=vechny soubory (SHR), 16=pouze adrese (D)
'
'B-HB
'7-128
'6--64
'5--32-A-Not Archive        -Neni archivovan
'4--16-D-subDirectory entry -Adresar
'3---8-V-Volume label entry -Jednotka
'2---4-S-System             -Systemovy
'1---2-H-Hidden             -Skryty
'0---1-R-Read-only          -Jen pro cteni
'
'B-slo bitu HB-Hodnota bitu
'-------------------------------------------------------------
'Datum souboru:                Cas souboru:
'CB--HB2B-HBB                  CB--HB2B-HBB
'15-32768-128|                 15-32768-128|
'14-16384--64|                 14-16384--64|
'13--8192--32|                 13--8192--32|
'12--4096--16|                 12--4096--16|
'11--2048---8|                 11--2048---8\Hodina (0-23)
'10--1024---4|                 10--1024---4|
' 9---512---2\Rok-1980 (0-119)  9---512---2|
' 8---256---1|                  8---256---1|
' 7---128-128|                  7---128-128|
' 6----64--64|                  6----64--64|
' 5----32--32\Mesic (1-12)      5----32--32\Minuta (0-59)
' 4----16--16|                  4----16--16|
' 3-----8---8|                  3-----8---8|
' 2-----4---4|                  2-----4---4|
' 1-----2---2|                  1-----2---2|
' 0-----1---1\Den (0-31)        0-----1---1\Vterina/2 (0-30)
'
'CB-Cislo bitu HB2B-Hodnota bitu ve dvojici bajtu
'HBB-Hodnota bitu v bajtu
'-------------------------------------------------------------
'Flags register (reg(8)):
'
'5432109876543210
'xxxxODITSZxAxPxC
'
'O=overflow, peteen
'D=direction, smr
'I=interrupt, povolen peruen
'T=trap, trasovn, pouv se u ladcch program, vyvolv INT 3 po kad instrukci
'S=sign, znamnko, 1, je-li vsledek zporn
'Z=zero, nula, 1, je-li vsledek nulov
'A=auxiliary carry, pomocn vlajka penosu, 1, je-li penost z doln poloviny 8 nebo 16 bitovho sla
'P=parity, parita, 1 pi sudm potu bit vsledku
'C=carry, penos, pro penos mezi sly o vce slovech
'-------------------------------------------------------------
'reg(1)= AX = AH,AL
'reg(2)= BX = BH,BL
'reg(3)= CX = CH,BL
'reg(4)= DX = DH,DL
'reg(5)= BP
'reg(6)= SI
'reg(7)= DI
'reg(8)= FLAGS
'reg(9)= DS
'reg(10)=ES
'-------------------------------------------------------------

