DECLARE SUB zobraz (text$, font$, b1%, b2%, x%, y%)
DECLARE FUNCTION csdate$ ()
CONST piover180 = 3.141592 / 180
'ruikov hodiny (pepsno z Atari Basicu, zdokonaleno)

SCREEN 12
LINE (0, 0)-(639, 479), 1, BF
OPEN "fonty\kamenic.fon" FOR BINARY ACCESS READ AS #1
font$ = INPUT$(4096, #1): CLOSE #1

sx = 320: sy = 240   'souradnice stredu hodin
r1 = 200        'polomer okraje ciferniku
r2 = .95 * r1   'polomer znacek na ciferniku
r3 = r2 - 3     'polomer minutove rucicky
r4 = .8 * r1    'polomer hodinove rucicky

CIRCLE (sx, sy), r1, 14

FOR x = -90 TO 270 STEP 6
  PSET (sx + COS(piover180 * x) * r2, sy + SIN(piover180 * x) * r2), 14
NEXT

FOR x = -90 TO 270 STEP 30
  a = sx + COS(piover180 * x) * r2: b = sy + SIN(piover180 * x) * r2
  LINE (a - 1, b - 1)-(a + 1, b - 1), 14
  LINE (a + 1, b - 1)-(a + 1, b + 1), 14
  LINE (a + 1, b + 1)-(a - 1, b + 1), 14
  LINE (a - 1, b + 1)-(a - 1, b), 14
NEXT

CALL zobraz("(c) JJsoft 2001 - ruikov hodiny, zdokonalen program z Atari-Basicu (1986-89)", font$, 11, 1, 464, 0) 'copyright


c = -1: d = -1: e = -1 'pedel sekunda, minuta a hodina

DO WHILE ink$ = ""   'hodiny bezi do stisku libovolne klavesy
  DO  'cekej na zmenu sekundy, nebo na stisk klavesy
    t = INT(TIMER + .5)              'systemovy cas (pocet sekund od pulnoci)
    m = INT(t / 60): s = t - 60 * m  'minuty, sekundy
    h = INT(m / 60): m = m - 60 * h  'hodiny
    sr = s * 6 - 90                     'uhel sekundove rucicky
    mr = (m + INT(s / 5) / 12) * 6 - 90 'uhel minutove rucicky
    hr = (h + (m / 60)) * 30 - 90       'uhel hodinove rucicky
    ink$ = INKEY$
  LOOP WHILE s = c AND ink$ = ""
  IF ink$ <> "" THEN EXIT DO   'stisk klavesy- konec

  LINE (sx, sy)-(sx + COS(piover180 * cr) * r3, sy + SIN(piover180 * cr) * r3), 1  'smaz starou sekundovou rucicku

  IF mr <> dr THEN  'pri posunu minutove rucicky smaz starou
    LINE (sx, sy)-(sx + COS(piover180 * dr) * r3, sy + SIN(piover180 * dr) * r3), 1
  END IF
  IF hr <> er THEN  'pri posunu hodinove rucicky smaz starou
    LINE (sx, sy)-(sx + COS(piover180 * er) * r4, sy + SIN(piover180 * er) * r4), 1
  END IF
 
  CALL zobraz(TIME$, font$, 14, 1, (sy) - .4 * r1, 36)  'zobraz digitalni cas
  CALL zobraz(csdate$, font$, 11, 1, (sy) - 8, (sx + .4 * r1) / 8) 'zobraz datum

  LINE (sx, sy)-(sx + COS(piover180 * mr) * r3, sy + SIN(piover180 * mr) * r3), 14  'nakresli novou minutovou rucicku
  d = m: dr = mr

  LINE (sx, sy)-(sx + COS(piover180 * hr) * r4, sy + SIN(piover180 * hr) * r4), 14  'nakresli novou hodinovou rucicku
  e = h: er = hr

  LINE (sx, sy)-(sx + COS(piover180 * sr) * r3, sy + SIN(piover180 * sr) * r3), 12  'nakresli novou sekundovou rucicku
  c = s: cr = sr

LOOP

'pozn:je nutne vykreslovat hodinovou a minutovou rucicku stale znova
'protoze vterinova by mohla pri posunu smazat minutovou nebo hodinovou a taky
'minutova by mohla smazat hodinovou
'to bylo castecne osetreno jiz v puvodnim Atari-programu,
'zde je to zdokonaleno


FUNCTION csdate$
d$ = DATE$
csdate$ = MID$(d$, 4, 2) + "." + MID$(d$, 1, 2) + "." + MID$(d$, 7, 4)
END FUNCTION

DEFINT A-Z
SUB zobraz (text$, font$, b1, b2, x, y)
SHARED zobrasm$
'ped pouitm rutiny mus bt nastaven grafick md SCREEN 12 ! (nebo 9)
IF zobrasm$ = "" THEN
  'BEEP
  f$ = ""
  f$ = f$ + MKL$(-1947432107) + MKL$(394989662) + MKL$(50493323) + MKL$(12276438) + MKL$(-1950118240) + MKL$(126552158) + MKL$(-150974278) + MKL$(-1946645534)
  f$ = f$ + MKL$(1057162846) + MKL$(-826667126) + MKL$(-301420541) + MKL$(-1341927494) + MKL$(-994382081) + MKL$(-301813757) + MKL$(-1174290456) + MKL$(28312517)
  f$ = f$ + MKL$(-74818834) + MKL$(-2146310272) + MKL$(57999615) + MKL$(-2147438360) + MKL$(57999871) + MKL$(-2147426840) + MKL$(58003711) + MKL$(-2147413528)
  f$ = f$ + MKL$(58003967) + MKL$(1375815656) + MKL$(-1341930054) + MKL$(-1973752318) + MKL$(585597179) + MKL$(1962999680) + MKL$(8644611) + MKL$(1963130752)
  f$ = f$ + MKL$(11593731) + MKL$(1965096832) + MKL$(15001603) + MKL$(1965227904) + MKL$(18540547) + MKL$(63289938) + MKL$(1525548208) + MKL$(-410977398)
  f$ = f$ + MKL$(16744516) + MKL$(1458045813) + MKL$(83853312) + MKL$(-2081946763) + MKL$(1090486272) + MKL$(-1209531531) + MKL$(1157595136) + MKL$(-303561867)
  f$ = f$ + MKL$(-977645056) + MKL$(-301420541) + MKL$(-2130998694) + MKL$(-8353561) + MKL$(-402426624) + MKL$(-8388567) + MKL$(-402426616) + MKL$(-8388522)
  f$ = f$ + MKL$(-402426496) + MKL$(-8388470) + MKL$(-402426488) + MKL$(-977665856) + MKL$(-285233149) + MKL$(838237) + MKL$(-947846991) + MKL$(1455621296)
  f$ = f$ + MKL$(-230993577) + MKL$(-109047437) + MKL$(-402426544) + MKL$(183042026) + MKL$(-28948736) + MKL$(1508633537) + MKL$(1472421471) + MKL$(280056150)
  f$ = f$ + MKL$(1946220928) + MKL$(96871947) + MKL$(-2083914240) + MKL$(-253013817) + MKL$(-1017160103) + MKL$(995186518) + MKL$(-2146339854) + MKL$(58020089)
  f$ = f$ + MKL$(-385894936) + MKL$(1195769866) + MKL$(-336870914) + MKL$(-1017225383) + MKL$(1397839447) + MKL$(-1325364504) + MKL$(16351248) + MKL$(478809460)
  f$ = f$ + MKL$(-31619034) + MKL$(-947697975) + MKL$(1542384464) + MKL$(-1017160103) + MKL$(995186518) + MKL$(-2146339854) + MKL$(58020089) + MKL$(-385910296)
  f$ = f$ + MKL$(1195769866) + MKL$(-336870914) + MKL$(-1017225383) + MKL$(1397839447) + MKL$(-1325379864) + MKL$(16351248) + MKL$(478809972) + MKL$(-2010721290)
  f$ = f$ + MKL$(1187642909) + MKL$(-347027581) + MKL$(1582914540) + MKL$(1448592223) + MKL$(1945254737) + MKL$(1358528529) + MKL$(1005060981) + MKL$(715007)
  f$ = f$ + MKL$(-1040300473) + MKL$(1582951403) + MKL$(1364706143) + MKL$(-109047631) + MKL$(638284800) + MKL$(-16841274) + MKL$(1355252681) + MKL$(1599729899)
  f$ = f$ + MKL$(-1269608253) + MKL$(-788231680) + MKL$(-773795360) + MKL$(-1948200480) + MKL$(2005601886) + MKL$(1542456066) + MKL$(-1957575848) + MKL$(260705374)
  f$ = f$ + MKL$(-1979031925) + MKL$(-791049665) + MKL$(-790114073) + MKL$(182964455) + MKL$(12802527)
  zobrasm$ = f$: f$ = ""
END IF
DEF SEG = VARSEG(zobrasm$)
ptr% = VARPTR(zobrasm$): rutptr% = CVI(CHR$(PEEK(ptr% + 2)) + CHR$(PEEK(ptr% + 3)))
CALL ABSOLUTE(text$, font$, b1, b2, x, y, rutptr%)
END SUB

