'Rzn sluby pouvan v TXOVL.BAS a v mnoha jinch modulech
'Vyvinuto ji v devadestch letech
'Novj verze vyvjena ve FILES.BAS, STRINGS.BAS, WAITING.BAS...
'od prosince 2004
'Oproti SLUZBY0.BAS potebuje volat rutiny DOSu pes int86xold

DECLARE FUNCTION padc$ (txt$, delk%, zn$)
DECLARE FUNCTION disks$ (x, y)
DECLARE FUNCTION exist (file$)
DECLARE FUNCTION dir$ (spec$, mask$)
DECLARE FUNCTION curdir$ (disk$)
DECLARE FUNCTION isdiskin (disk$)
DECLARE FUNCTION iif (yn, y, n)
DECLARE FUNCTION iifs$ (yn, y$, n$)
DECLARE FUNCTION padr$ (text$, delk%, zn$)
DECLARE FUNCTION padl$ (text$, delk%, zn$)
DECLARE FUNCTION rat (kde$, co$, odk)
DECLARE SUB keys (scan, asci, ink$, vl$)
DECLARE SUB asmcalc (op1%, op2%, vysl%, flags%, opkod$)
DECLARE FUNCTION ldfont$ (file$)
'Tento modul obsahuje pouze uivatelsk funkce,
'kter je mono pouvat v textovm i grafickm reimu. (nemaj vstup na obrazovku)
'na rozdl od sluzby0 pouv rutiny int86xold,absolute z qb.qlb

SUB asmcalc (op1%, op2%, vysl%, flags%, opkod$)
'vol aritmetick instrukce assembleru
SHARED asmrut3$, opkody$

IF opkody$ = "" THEN          'nate seznam instrukc, nen-li naten
  opkody$ = opkody$ + "add" + CHR$(&H3) + CHR$(&HC1) + "adc" + CHR$(&H13) + CHR$(&HC1)
  opkody$ = opkody$ + "sub" + CHR$(&H2B) + CHR$(&HC1) + "sbb" + CHR$(&H1B) + CHR$(&HC1)
  opkody$ = opkody$ + "cmp" + CHR$(&H3B) + CHR$(&HC1) + "and" + CHR$(&H23) + CHR$(&HC1)
  opkody$ = opkody$ + "or " + CHR$(&HB) + CHR$(&HC1) + "xor" + CHR$(&H33) + CHR$(&HC1)
  opkody$ = opkody$ + "tst" + CHR$(&H85) + CHR$(&HC1)
  opkody$ = opkody$ + "rol" + CHR$(&HD3) + CHR$(&HC0) + "ror" + CHR$(&HD3) + CHR$(&HC8)
  opkody$ = opkody$ + "rcl" + CHR$(&HD3) + CHR$(&HD0) + "rcr" + CHR$(&HD3) + CHR$(&HD8)
  opkody$ = opkody$ + "shl" + CHR$(&HD3) + CHR$(&HE0) + "sal" + CHR$(&HD3) + CHR$(&HE0)
  opkody$ = opkody$ + "shr" + CHR$(&HD3) + CHR$(&HE8) + "sar" + CHR$(&HD3) + CHR$(&HF8)
  opkody$ = opkody$ + "not" + CHR$(&HF7) + CHR$(&HD0) + "neg" + CHR$(&HF7) + CHR$(&HD8)
  opkody$ = opkody$ + "mul" + CHR$(&HF6) + CHR$(&HE1) + "imu" + CHR$(&HF6) + CHR$(&HE9)
  opkody$ = opkody$ + "div" + CHR$(&HF6) + CHR$(&HF1) + "idi" + CHR$(&HF6) + CHR$(&HF9)
  opkody$ = opkody$ + "inc" + CHR$(&H40) + CHR$(&H90) + "dec" + CHR$(&H48) + CHR$(&H90)
  opkody$ = opkody$ + "aaa" + CHR$(&H37) + CHR$(&H90) + "daa" + CHR$(&H27) + CHR$(&H90)
  opkody$ = opkody$ + "aas" + CHR$(&H3F) + CHR$(&H90) + "das" + CHR$(&H2F) + CHR$(&H90)
  opkody$ = opkody$ + "aam" + CHR$(&HD4) + CHR$(&HA) + "aad" + CHR$(&HD5) + CHR$(&HA)
  opkody$ = opkody$ + "cbw" + CHR$(&H98) + CHR$(&H90) + "cwd" + CHR$(&H99) + CHR$(&H90)
END IF

IF asmrut3$ = "" THEN           'nate assembler-rutinu, nen-li natena
  f$ = f$ + MKL$(-1947432107) + MKL$(126553182) + MKL$(-1962254709) + MKL$(-1950285041) + MKL$(126421086) + MKL$(-1626972533) + MKL$(-899872887) + MKL$(8)
  asmrut3$ = f$: f$ = ""
END IF

at = INSTR(opkody$, opkod$)     'zjist umstn nzvu instrukce v seznamu
IF at = 0 THEN
  PRINT "Instrukce " + UCASE$(opkod$) + " nen znma."
END IF

MID$(asmrut3$, 14, 2) = MID$(opkody$, at + 3, 2)  'dopln kd aritmetick instrukce do rutiny

DEF SEG = VARSEG(asmrut3$)        'zjist umstn rutiny v pamti
PTR% = VARPTR(asmrut3$): rutptr3% = CVI(CHR$(PEEK(PTR% + 2)) + CHR$(PEEK(PTR% + 3)))

CALL ABSOLUTE(op1%, op2%, vysl%, flags%, rutptr3%)  'zavol rutinu

END SUB

FUNCTION curdir$ (disk$)
DIM reg(1 TO 10) AS INTEGER
DIM buffer AS STRING * 64
disk$ = UCASE$(disk$)
IF disk$ = "" THEN
  reg(1) = &H1900
  CALL int86xold(&H21, reg(), reg())
  cd$ = CHR$((reg(1) MOD 256) + 65) + ":\"
ELSE
  cd$ = disk$ + "\"
END IF
reg(1) = &H4700
reg(9) = VARSEG(buffer)
reg(6) = VARPTR(buffer)
IF disk$ = "" THEN reg(4) = 0 ELSE reg(4) = ASC(disk$) - 64
CALL int86xold(&H21, reg(), reg())
FOR x = 1 TO 65
  IF ASC(MID$(buffer, x, 1)) = 0 THEN EXIT FOR
NEXT
curdir$ = cd$ + MID$(buffer, 1, x - 1)
END FUNCTION

FUNCTION dir$ (spec$, mask$)
'Funkce napln etzec nzvy soubor pro zadan adres a masku
DIM reg(1 TO 10) AS INTEGER
DIM soubor AS STRING * 65
DIM dta AS STRING * 44
IF mask$ = "" THEN mask$ = "*.*"
IF NOT (LEN(spec$) = 2 AND MID$(spec$, 2, 1) = ":") AND RIGHT$(spec$, 1) <> "\" THEN spec$ = spec$ + "\"
reg(1) = &H1A00
reg(4) = VARPTR(dta)
reg(9) = VARSEG(dta)
CALL int86xold(&H21, reg(), reg())  'pesmruj DTA
soubor = spec$ + "*.*" + CHR$(0)
reg(1) = &H4E00
reg(4) = VARPTR(soubor)
reg(9) = VARSEG(soubor)
reg(3) = 16
MID$(dta, &H1F, 12) = SPACE$(12)
CALL int86xold(&H21, reg(), reg())  'nati prvn adres
IF reg(1) = 0 AND (ASC(MID$(dta, &H16, 1)) AND 16) = 16 AND MID$(dta, &H1F, 1) <> "." THEN
  GOSUB cleachr0
  d$ = d$ + MID$(dta, &H1F, 12)
END IF
reg(1) = 0
DO WHILE -1  'nati zbyl adrese
  reg(1) = &H4F00
  MID$(dta, &H1F, 12) = SPACE$(12)
  CALL int86xold(&H21, reg(), reg()): IF reg(1) <> 0 THEN EXIT DO
  IF (ASC(MID$(dta, &H16, 1)) AND 16) = 16 AND MID$(dta, &H1F, 1) <> "." THEN
    GOSUB cleachr0
    d$ = d$ + MID$(dta, &H1F, 12)
  END IF
LOOP
FOR y = LEN(d$) / 12 - 2 TO 0 STEP -1  'seti podle abecedy
  FOR x = 0 TO y
    x$ = MID$(d$, 1 + 12 * x, 12)
    IF x$ > MID$(d$, 1 + 12 * (x + 1), 12) THEN
      MID$(d$, 1 + 12 * x, 12) = MID$(d$, 1 + 12 * (x + 1), 12)
      MID$(d$, 1 + 12 * (x + 1), 12) = x$
    END IF
  NEXT
NEXT
soubor = spec$ + mask$ + CHR$(0)
reg(1) = &H4E00
reg(4) = VARPTR(soubor)
reg(9) = VARSEG(soubor)
reg(3) = 7
MID$(dta, &H1F, 12) = SPACE$(12)
CALL int86xold(&H21, reg(), reg())  'nati prvn soubor
IF reg(1) = 0 THEN
  GOSUB cleachr0
  f$ = f$ + LCASE$(MID$(dta, &H1F, 12))
END IF
reg(1) = 0
DO WHILE -1  'nati zbyl soubory
  reg(1) = &H4F00
  MID$(dta, &H1F, 12) = SPACE$(12)
  CALL int86xold(&H21, reg(), reg()): IF reg(1) <> 0 THEN EXIT DO
  GOSUB cleachr0
  f$ = f$ + LCASE$(MID$(dta, &H1F, 12))
LOOP
FOR y = LEN(f$) / 12 - 2 TO 0 STEP -1  'seti podle abecedy
  FOR x = 0 TO y
    x$ = MID$(f$, 1 + 12 * x, 12)
    IF x$ > MID$(f$, 1 + 12 * (x + 1), 12) THEN
      MID$(f$, 1 + 12 * x, 12) = MID$(f$, 1 + 12 * (x + 1), 12)
      MID$(f$, 1 + 12 * (x + 1), 12) = x$
    END IF
  NEXT
NEXT
dir$ = d$ + f$ + STRING$(LEN(d$) / 12, 1) + STRING$(LEN(f$) / 12, 0)
EXIT FUNCTION

cleachr0:  'vyist nzev souboru z DTA od znak CHR(0)
FOR x = &H1F + 11 TO &H1F STEP -1
  x$ = MID$(dta, x, 1)
  IF x$ <> CHR$(0) AND x$ <> " " THEN EXIT FOR
  IF x$ = CHR$(0) THEN MID$(dta, x, 1) = " "
NEXT
RETURN

END FUNCTION

FUNCTION disks$ (x, y)
'Funkce vrac etzec vech dostupnch disk
DIM dta AS STRING * 44
DIM soubor AS STRING * 7
DIM reg(1 TO 10) AS INTEGER

OUT &H70, &H10: x = INP(&H71)           'zjisti disketov mechaniky
typa = INT(x / 16): typb = x MOD 16
IF typa <> 0 OR typb <> 0 THEN
  IF typb = 0 OR typa = 0 THEN      '1 mechanika-testuj fantom floppy
    DEF SEG = 0
    IF PEEK(&H504) <> 0 THEN d$ = "B:" ELSE d$ = "A:"
  ELSE
    d$ = "A:B:"
  END IF
ELSE
  d$ = ""
END IF
reg(1) = &H1A00
reg(9) = VARSEG(dta)
reg(4) = VARPTR(dta)
CALL int86xold(&H21, reg(), reg())
FOR n = 67 TO 90
  soubor = CHR$(n) + ":\nul" + CHR$(0)
  reg(1) = &H4E00
  reg(3) = 0
  reg(9) = VARSEG(soubor)
  reg(4) = VARPTR(soubor)
  CALL int86xold(&H21, reg(), reg())
  IF reg(1) = 0 OR reg(1) = 18 THEN d$ = d$ + CHR$(n) + ":"
  'PRINT CHR$(n); reg(1); " ";
NEXT
disks$ = d$
END FUNCTION

FUNCTION exist (file$)
'Funkce testuje existenci souboru
DIM reg(1 TO 10) AS INTEGER
DIM soubor AS STRING * 65
DIM dta AS STRING * 44
soubor = file$ + CHR$(0)
reg(1) = &H1A00
reg(4) = VARPTR(dta)
reg(9) = VARSEG(dta)
CALL int86xold(&H21, reg(), reg())  'pesmruj DTA
reg(1) = &H4E00
reg(4) = VARPTR(soubor)
reg(9) = VARSEG(soubor)
reg(3) = 7
CALL int86xold(&H21, reg(), reg())  'nati soubor do DTA
IF reg(1) = 0 THEN exist = -1 ELSE exist = 0  'vra -1, nebyla-li chyba
END FUNCTION

FUNCTION iif (yn, y, n)
IF yn THEN iif = y ELSE iif = n
END FUNCTION

FUNCTION iifs$ (yn, y$, n$)
IF yn THEN iifs$ = y$ ELSE iifs$ = n$
END FUNCTION

FUNCTION isdiskin (disk$)
'Je v mechanice disketa?
DIM reg(1 TO 10) AS INTEGER
dl = ASC(UCASE$(disk$)) - 65 'slo mechaniky
IF dl > 1 THEN isdiskin = -1: EXIT FUNCTION
DEF SEG = 0
dl = dl - PEEK(&H504) 'odeti fantom-floppy
reg(1) = CVI(CHR$(1) + CHR$(4))  'ax
reg(3) = CVI(CHR$(1) + CHR$(0))  'cx
reg(4) = CVI(CHR$(dl) + CHR$(0)) 'dx
CALL int86xold(&H13, reg(), reg()) 'kontroluj 1. sektor
x = ASC(MID$(MKI$(reg(1)), 2, 1)) 'chyba v ah
IF x = 0 OR x = 6 THEN isdiskin = -1 ELSE isdiskin = 0
END FUNCTION

SUB keys (scan, asci, ink$, vl$)
'Funkce vrac informace o stavu klvesnice
'vl$=vlastnosti: w-ek,pokud je buffer przdn

DEF SEG = 0: uvl$ = UCASE$(vl$)

IF INSTR(uvl$, "W") THEN  'ek,pokud je buffer przdn
  adrh = CVI(CHR$(PEEK(&H41A)) + CHR$(PEEK(&H41B)))  'adresa hlavy bufferu
  DO WHILE adrh = CVI(CHR$(PEEK(&H41C)) + CHR$(PEEK(&H41D)))
  LOOP
END IF

adrk = CVI(CHR$(PEEK(&H41C)) + CHR$(PEEK(&H41D)))  'adresa konce bufferu

znadr = adrk MOD 32
scan = PEEK(znadr + &H41E + 1)
asci = PEEK(znadr + &H41E)
ink$ = INKEY$

IF INSTR(uvl$, "R") THEN  'vyist buffer
  adrk = CVI(CHR$(PEEK(&H41C)) + CHR$(PEEK(&H41D)))  'adresa konce bufferu
  adrh = CVI(CHR$(PEEK(&H41A)) + CHR$(PEEK(&H41B)))  'adresa zatku bufferu
  pzn = ((adrk - adrh + 32) MOD 32) / 2              'poet znak v bufferu
  FOR x = 1 TO pzn
    xx$ = INKEY$
  NEXT
END IF

END SUB

FUNCTION ldfont$ (file$)

ff = FREEFILE
OPEN file$ FOR BINARY ACCESS READ AS #ff
ldfont$ = INPUT$(4096, #ff): CLOSE #ff

END FUNCTION

DEFINT A-Z
FUNCTION padc$ (txt$, delk, zn$)
  text$ = txt$: IF zn$ = "" THEN zn$ = " "
  IF delk < 0 THEN delk = 0
  IF text$ = "" THEN text$ = zn$
  IF LEN(text$) > delk THEN
    zac = INT((1 + LEN(text$) - delk) / 2)
    text$ = MID$(text$, zac, delk)
  ELSE
    dc = delk - LEN(text$)
    d1 = INT(dc / 2): d2 = dc - d1
    text$ = STRING$(d1, zn$) + text$ + STRING$(d2, zn$)
  END IF
  padc$ = text$

END FUNCTION

FUNCTION padl$ (txt$, delk, zn$)
  text$ = txt$: IF zn$ = "" THEN zn$ = " "
  IF delk < 0 THEN delk = 0
  IF text$ = "" THEN text$ = zn$
  IF LEN(text$) > delk THEN
    text$ = MID$(text$, 1, delk)
  ELSE
    text$ = text$ + STRING$(delk - LEN(text$), zn$)
  END IF
  padl$ = text$

END FUNCTION

FUNCTION padr$ (txt$, delk, zn$)
  text$ = txt$: IF zn$ = "" THEN zn$ = " "
  IF delk < 0 THEN delk = 0
  IF text$ = "" THEN text$ = zn$
  IF LEN(text$) > delk THEN
    text$ = MID$(text$, LEN(text$) - delk + 1)
  ELSE
    text$ = STRING$(delk - LEN(text$), zn$) + text$
  END IF
  padr$ = text$

END FUNCTION

DEFSNG A-Z
FUNCTION rat (kde$, co$, odk)
'vrac posledn vskyt etzce co$ v kde$ od pozice odk (doleva)
IF odk < 1 OR odk > LEN(kde$) THEN odks = LEN(kde$) ELSE odks = odk
h1 = 1
kdes$ = MID$(kde$, 1, odks)
h2 = LEN(kdes$)
IF h2 = 0 OR LEN(co$) = 0 OR INSTR(kdes$, co$) = 0 THEN rat = 0: EXIT FUNCTION

DO WHILE -1
  IF h2 = h1 THEN
    rat = h1: EXIT DO
  ELSE
    s = INT((h1 + h2 + 1) / 2)
    IF INSTR(MID$(kde$, s, 1 + h2 - s), co$) = 0 THEN 'druh polovina je przdn
      h2 = s - 1
    ELSE
      h1 = s
    END IF
  END IF
LOOP
END FUNCTION

