DECLARE FUNCTION flags0 (byte, flag, akce)
DECLARE FUNCTION centerstr$ (text$, delka, char$)
DECLARE FUNCTION flags (byte%, flag%, akce%)
DECLARE SUB ctverecek (rd, sl, vyska, sirka, popredi, pozadi, znak$)

DEF SEG = 0          'nastav se na pln zatek operan pamti

rych = VAL(COMMAND$) / 1000     'rychlost v tiscinch sekundy nastaviteln parametrem
IF rych < .1 THEN rych = .1     'rychlost pod 0.1 sekundy na kmit nepipoutm

COLOR 14, 1
CLS
COLOR 14, 3
PRINT centerstr$("-- Program LOCKS - (c) JJ-soft jen 1994, prosinec 2004 --", 80, "")
COLOR 14, 1
PRINT : PRINT
PRINT centerstr$("Podvejte se, jak Vm svtlkuje NumLock, Capslock a ScrollLock.", 80, "")
PRINT centerstr$("A Vs to pestane bavit, stisknte cokoliv.", 80, "")

DIM puvbit(0 TO 3) AS INTEGER   'pvodn hodnoty bit
DIM puvbyte AS INTEGER, i AS INTEGER, j AS INTEGER, bajt AS INTEGER
puvbyte = PEEK(&H417)   'pvodn hodnota bajtu

puvbit(0) = flags(puvbyte, 4, 2)   'zjisti scroll lock (vsledek 0 nebo 1)
puvbit(1) = flags(puvbyte, 5, 2)   'zjisti num lock (vsledek 0 nebo 1)
puvbit(2) = flags(puvbyte, 6, 2)   'zjisti caps lock (vsledek 0 nebo 1)

DIM zobrbit(0 TO 3) AS INTEGER   'kde m bt bit zobrazen
zobrbit(0) = 2    'scroll lock jako tet
zobrbit(1) = 0    'num lock jako prvn
zobrbit(2) = 1    'caps lock jako druh

LOCATE 9, 15: PRINT "Num Lock"
LOCATE 9, 35: PRINT "Caps Lock"
LOCATE 9, 55: PRINT "Scroll Lock"

FOR x = 0 TO 2
  CALL ctverecek(11, 17 + 20 * zobrbit(x), 2, 4, 8 + 2 * puvbit(x), 1, "")
NEXT

bajt = puvbyte      'pvodn bajt

DO WHILE INKEY$ = ""
  j = INT(RND(1) * 3)       'nhodn vbr 0,1,2
  i = 4 + j                 'nhodn vbr ze t Lock (bity 4,5,6)
  bajt = flags(bajt, i, -1) 'zm bit
  POKE &H417, bajt          'zapi zmnn bajt do operan pamti
  stavbitu = flags(bajt, i, 2) 'jak je te stav bitu?
  LOCATE 20, 1: COLOR 7
  'PRINT "bit      "; j; i; zobrbit(j)
  'PRINT "stav bitu"; stavbitu
  'PRINT "stav bajtu"; bajt; PEEK(&H417)
  tm = TIMER: DO WHILE TIMER - tm < rych: LOOP   'a ekej
  CALL ctverecek(11, 17 + 20 * zobrbit(j), 2, 4, 8 + 2 * stavbitu, 1, "") 'zobraz stav bitu
LOOP

'bajt = PEEK(&H417)        'znovu zjisti aktuln hodnotu bajtu
bajt = 0
bajt = flags(bajt, 4, (puvbit(0)))  'a dopl do nj pvodn bity
bajt = flags(bajt, 5, (puvbit(1)))
bajt = flags(bajt, 6, (puvbit(2)))

POKE &H417, bajt      'nastaven hodnoty bajtu s pvodnmi bity

COLOR 7, 0
CLS
END

FUNCTION centerstr$ (text$, delka, char$)
  'centrovn etzce na urenou dlku

  puvodnidelka = LEN(text$)
  odsazeni = delka - puvodnidelka
  IF odsazeni <= 0 THEN
    centerstr$ = text$
    EXIT FUNCTION
  END IF
  odsazeni1 = INT(.5 + odsazeni / 2)
  odsazeni2 = odsazeni - odsazeni1
  IF char$ = "" THEN char$ = " " ELSE char$ = LEFT$(char$, 1)
  centerstr$ = STRING$(odsazeni1, char$) + text$ + STRING$(odsazeni2, char$)

END FUNCTION

SUB ctverecek (rd, sl, vyska, sirka, popredi, pozadi, znak$)
  'vykresl tvereek

  COLOR popredi, pozadi
  FOR x = rd TO rd + vyska - 1
    LOCATE x, sl: PRINT STRING$(sirka, znak$)
  NEXT

END SUB

FUNCTION flags (byte AS INTEGER, flag AS INTEGER, akce AS INTEGER)
  DIM hbit AS INTEGER
  'vrac stav jednoho bitu z sla <byte> nebo slo upraven
  'flag=poadov slo bitu
  'akce= -1=inverze (XOR 1) (vsledek=cel bajt)
  '       0=dopl 0 (AND 0) (vsledek=cel bajt)
  '       1=dopl 1 (OR  1) (vsledek=cel bajt)
  '       2 nebo jin slo=ti bit (vsledek 0 nebo 1)

  hbit = 2 ^ flag     'hodnota bitu v sle <byte>
  SELECT CASE akce
    CASE -1                'inverze (XOR 1)
      flags = byte XOR hbit
    CASE 0                 'dopl 0 (AND 0)
      flags = byte AND (NOT hbit)
    CASE 1                 'dopl 1 (OR 1)
      flags = byte OR hbit
    CASE ELSE              'ti bit
      flags = SGN(byte AND hbit)
  END SELECT

END FUNCTION

FUNCTION flags0 (byte, flag, akce)
'vrac stav jednoho bitu z sla <byte> nebo slo upraven (star verze)
'flag=poadov slo bitu
'akce= -1=inverze (XOR 1)
'       0=dopl 0 (AND 0)
'       1=dopl 1 (OR  1)
'       jin slo=ti bit

mc = 2 ^ flag: mch = mc * 2
SELECT CASE akce
  CASE -1
    x = byte MOD mch: x = byte - 2 * (x - x MOD mc) + mc
    flags0 = x
  CASE 0
    x = byte MOD mch: x = byte - (x - x MOD mc)
    flags0 = x
  CASE 1
    x = byte MOD mch: x = byte - (x - x MOD mc) + mc
    flags0 = x
  CASE ELSE
    x = byte MOD mch: x = (x - x MOD mc) / mc
    flags0 = x
END SELECT

END FUNCTION

