DEFINT A-Z
TYPE vektor
  x AS INTEGER
  y AS INTEGER
END TYPE
TYPE interval
  min AS INTEGER
  max AS INTEGER
END TYPE
DECLARE SUB cleahp ()
DECLARE SUB pisxo (v AS vektor, xo$)
DECLARE SUB setcurs (v AS vektor)
DECLARE SUB ctixo (v AS vektor, xo$)
DECLARE FUNCTION min (a, b)
DECLARE FUNCTION max (a, b)
DECLARE SUB spoctixo (v AS vektor, v2 AS vektor, xo$)
DECLARE FUNCTION antiznak$ (xo$)
DIM pole(0 TO 24) AS STRING * 80
DIM poz AS vektor, vel AS vektor, pozh AS vektor, pozp AS vektor, mpoz AS vektor
DIM mpozp AS vektor
DIM smer(0 TO 3) AS vektor
smer(0).x = 1: smer(0).y = 0 'o o  o-  /
smer(1).x = 1: smer(1).y = 1 '|  \    o
smer(2).x = 0: smer(2).y = 1
smer(3).x = -1: smer(3).y = 1
DIM smint(0 TO 3) AS interval
DIM pocet(0 TO 3, 0 TO 4)     'poty X/O ve smrech a intervalech
DIM reg(1 TO 10) AS INTEGER

poz.x = 2: poz.y = 1 'pozice plochy na obrazovce
vel.x = 17: vel.y = 77 'velikost plochy
reg(1) = 0: CALL int86xold(&H33, reg(), reg())
CLS
COLOR 3, 0: LOCATE 1, 25: PRINT "PIKVORKY (C) JJ-SOFT 1995";
COLOR 2, 0: PRINT " (upraveno 12/2004)"
COLOR 3, 0
LOCATE vel.x + 6, 1: PRINT "Posun=ipky,PgDn,PgUp,End,Home  Tah=Enter,My  Nov hra=N  Konec=Esc"
GOSUB ini
pozh.x = INT(vel.x / 2): pozh.y = INT(vel.y / 2)
reg(1) = 1: CALL int86xold(&H33, reg(), reg()): mdown = 0
DO WHILE -1
  CALL setcurs(pozh)
  i$ = ""
  DO WHILE i$ = ""
    i$ = INKEY$
    GOSUB mys
  LOOP
  reg(1) = 2: CALL int86xold(&H33, reg(), reg())
  SELECT CASE i$
    CASE CHR$(0) + "H"
      pozh.x = (pozh.x + vel.x - 1) MOD vel.x
    CASE CHR$(0) + "P"
      pozh.x = (pozh.x + 1) MOD vel.x
    CASE CHR$(0) + "K"
      pozh.y = (pozh.y + vel.y - 1) MOD vel.y
    CASE CHR$(0) + "M"
      pozh.y = (pozh.y + 1) MOD vel.y
    CASE CHR$(0) + "G": pozh.y = 0
    CASE CHR$(0) + "O": pozh.y = vel.y - 1
    CASE CHR$(0) + "I": pozh.x = 0
    CASE CHR$(0) + "Q": pozh.x = vel.x - 1
    CASE CHR$(13)
      GOSUB tahx
    CASE CHR$(27)
      EXIT DO
    CASE "MYS"
      pozh.y = slmrel
      pozh.x = rdmrel
      GOSUB tahx
    CASE "P", "p"
      IF mpoz.x > -1 THEN
        pozh = mpoz
        GOSUB tahx
      END IF
    CASE "N", "n": GOSUB ini  'nov hra
    CASE ELSE
  END SELECT
  reg(1) = 1: CALL int86xold(&H33, reg(), reg())
LOOP
CLS
END

ini:
CALL cleahp
RETURN

tahx:    
CALL ctixo(pozh, x$)
  IF x$ <> " " THEN
    SOUND 37, 1
  ELSE
    CALL pisxo(pozh, "X")
    GOSUB protitah
  END IF
RETURN

protitah:
  CALL spoctixo(pozh, pozp, "X")
  IF maxpoc = 5 THEN
    mess$ = "Vyhrl jsi."
    GOSUB newgame
  ELSE
    IF pozp.x > -1 THEN
      CALL pisxo(pozp, "O"): mpozp = pozp
      GOSUB k5o
    ELSE
      CALL spoctixo(mpozp, pozp, "O")
      IF pozp.x > -1 THEN
        CALL pisxo(pozp, "O"): mpozp = pozp
        GOSUB k5o
      END IF
    END IF
  END IF
RETURN

newgame:
COLOR 2, 0: LOCATE vel.x + 4, 1, 0: PRINT mess$ + "Stiskni cokoliv.";
reg(1) = 1: CALL int86xold(&H33, reg(), reg())
i$ = ""
DO WHILE i$ = ""
  i$ = INKEY$: GOSUB mys
LOOP
i$ = ""
reg(1) = 2: CALL int86xold(&H33, reg(), reg())
LOCATE , 1: PRINT SPACE$(79);
GOSUB ini
pozh.x = INT(vel.x / 2): pozh.y = INT(vel.y / 2)
RETURN

k5o:    'kontrola na 5x"O"
CALL spoctixo(pozp, mpoz, "O")
IF maxpoc = 5 THEN
  mess$ = "Prohrl jsi.": GOSUB newgame
END IF
RETURN

mys:
reg(1) = 5: reg(2) = 0: CALL int86xold(&H33, reg(), reg())
IF mdown = (reg(1) MOD 2) THEN RETURN
mdown = (reg(1) MOD 2) 'zapamatuje nov stav tlatka
IF mdown = 1 THEN      'byl-li stisk, jde dl
  slm = reg(3) / 8: rdm = reg(4) / 8
  slmrel = slm - poz.y: rdmrel = rdm - poz.x
  IF slmrel >= 0 AND rdmrel >= 0 AND slmrel < vel.y AND rdmrel < vel.x THEN
    i$ = "MYS"
  END IF
END IF
RETURN

FUNCTION antiznak$ (xo$)
SELECT CASE xo$
  CASE "X": antiznak$ = "O"
  CASE "O": antiznak$ = "X"
  CASE "x": antiznak$ = "o"
  CASE "o": antiznak$ = "x"
  CASE ELSE: antiznak$ = xo$
END SELECT
END FUNCTION

SUB cleahp
'smae hrac pole tm,
'e vykresl ist oknko
SHARED pole() AS STRING * 80, poz AS vektor, vel AS vektor

COLOR 7, 0
LOCATE poz.x, poz.y: PRINT "" + STRING$(vel.y, "") + ""
FOR x = 1 TO vel.x
  pole(x - 1) = ""
  LOCATE poz.x + x, poz.y
  PRINT "" + STRING$(vel.y, "") + ""
NEXT
LOCATE poz.x + vel.x + 1, poz.y: PRINT "" + STRING$(vel.y, "") + ""

END SUB

SUB ctixo (v AS vektor, xo$)
SHARED pole() AS STRING * 80, poz AS vektor, vel AS vektor
xo$ = MID$(pole(v.x), v.y + 1, 1)
END SUB

FUNCTION max (a, b)
IF a > b THEN max = a ELSE max = b
END FUNCTION

FUNCTION min (a, b)
IF a < b THEN min = a ELSE min = b
END FUNCTION

SUB pisxo (v AS vektor, xo$)
SHARED pole() AS STRING * 80, poz AS vektor, vel AS vektor
x$ = MID$(xo$, 1, 1)
SELECT CASE x$
  CASE "X": COLOR 9
  CASE "x": COLOR 9 + 16
  CASE "O": COLOR 12
  CASE "o": COLOR 12 + 16
  CASE ELSE: COLOR 10
END SELECT
LOCATE poz.x + v.x + 1, poz.y + v.y + 1: PRINT UCASE$(x$)
MID$(pole(v.x), v.y + 1, 1) = x$
END SUB

SUB setcurs (v AS vektor)
SHARED poz AS vektor, vel AS vektor
LOCATE poz.x + v.x + 1, poz.y + v.y + 1, 1
END SUB

SUB spoctixo (v AS vektor, v2 AS vektor, xo$)
'dosad poty X/O do pole pocet,vrac optimln protitah ve v2
SHARED pole() AS STRING * 80, poz AS vektor, vel AS vektor
SHARED smint() AS interval, smer() AS vektor, pocet()
SHARED maxsmer, maxint, maxpoc
DIM pomp AS vektor, mpomp AS vektor

smint(0).min = max(4 - v.x, 0)
smint(0).max = min(vel.x - v.x - 1, 4)
smint(2).min = max(4 - v.y, 0)
smint(2).max = min(vel.y - v.y - 1, 4)
smint(1).min = max(smint(0).min, smint(2).min)
smint(1).max = min(smint(0).max, smint(2).max)
smint(3).min = max(smint(2).min, 4 - smint(0).max)
smint(3).max = min(smint(2).max, 4 - smint(0).min)

maxsmer = -1: maxint = 0: maxpoc = 0: ox$ = antiznak(xo$)
minpr = 5         'minimln poet pedl
FOR smer = 0 TO 3
  poc = 0: pocp = 0: pocpr = 0 'poet znak,protiznak,pedl
  FOR p = 0 TO smint(smer).min - 1
    pocet(smer, p) = -1
  NEXT
  IF smint(smer).min <= smint(smer).max THEN
    mx$ = ""
    FOR p = smint(smer).min - 4 TO smint(smer).min 'spoti prvn sekvenci
      pomp.x = v.x + smer(smer).x * p
      pomp.y = v.y + smer(smer).y * p
      CALL ctixo(pomp, x$)
      IF x$ = xo$ THEN poc = poc + 1
      IF x$ = ox$ THEN pocp = pocp + 1
      IF x$ <> mx$ THEN pocpr = pocpr + 1: mx$ = x$
    NEXT
    mx1$ = ""
    mx2$ = x$
    IF pocp = 0 THEN pocv = poc ELSE pocv = -1
    pocet(smer, smint(smer).min) = pocv
    IF pocv > maxpoc OR (pocv = maxpoc AND pocpr < minpr) THEN
      maxpoc = pocv: maxsmer = smer: maxint = smint(smer).min: minpr = pocpr
    END IF
    FOR p = smint(smer).min + 1 TO smint(smer).max
      pomp.x = v.x + smer(smer).x * (p - 5)
      pomp.y = v.y + smer(smer).y * (p - 5)
      CALL ctixo(pomp, x$)
      IF x$ = xo$ THEN poc = poc - 1
      IF x$ = ox$ THEN pocp = pocp - 1
      IF x$ <> mx1$ THEN pocpr = pocpr - 1: mx1$ = x$
      pomp.x = v.x + smer(smer).x * p
      pomp.y = v.y + smer(smer).y * p
      CALL ctixo(pomp, x$)
      IF x$ = xo$ THEN poc = poc + 1
      IF x$ = ox$ THEN pocp = pocp + 1
      IF x$ <> mx2$ THEN pocpr = pocpr + 1: mx2$ = x$
      IF pocp = 0 THEN pocv = poc ELSE pocv = -1
      pocet(smer, p) = pocv
      IF pocv > maxpoc OR (pocv = maxpoc AND pocpr < minpr) THEN
        maxpoc = pocv: maxsmer = smer: maxint = p: minpr = pocpr
      END IF
    NEXT
  END IF
  FOR p = smint(smer).max + 5 TO 4
    pocet(smer, p) = -1
  NEXT
NEXT

v2.x = -1: v2.y = -1
IF maxpoc = 5 THEN
  FOR p = 0 TO 4        'zvrazni vtznou ptici,byla-li
    pomp.x = v.x + (maxint - 4 + p) * smer(maxsmer).x
    pomp.y = v.y + (maxint - 4 + p) * smer(maxsmer).y
    CALL pisxo(pomp, LCASE$(xo$))
  NEXT
ELSE
  IF maxsmer > -1 THEN
    mx$ = ""
    FOR p = 0 TO 4        'jinak najdi vhodn protitah
      pomp.x = v.x + (maxint - 4 + p) * smer(maxsmer).x
      pomp.y = v.y + (maxint - 4 + p) * smer(maxsmer).y
      CALL ctixo(pomp, x$)
      IF x$ = " " AND mx$ = xo$ THEN v2 = pomp: EXIT FOR
      IF x$ = xo$ AND mx$ = " " THEN
        v2 = mpomp: EXIT FOR
      END IF
      mx$ = x$: mpomp = pomp
    NEXT
  END IF
END IF

END SUB

